import XConteudo
import OFS
import Globals
import time
import DateTime
from AccessControl import ClassSecurityInfo
from OFS.Folder import Folder
from OFS.Cache import Cacheable
from XWorkFlow import dt2us

_marker = []

class XPagina ( XConteudo.XConteudo ):
    """Classe que define a XPagina."""

    meta_type = 'XPagina'
    friendly_name = 'Pgina'

    security = ClassSecurityInfo()

    security.declareProtected('Modificar Propriedades da XPagina', 'manage_PropertiesForm')
    manage_PropertiesForm = Globals.DTMLFile("dtml/editXPaginaForm", globals(), in_ZMI=1)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','gadgetPropertiesForm')
    gadgetPropertiesForm = Globals.DTMLFile("dtml/editXPaginaForm", globals(), in_ZMI=0)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','manage_ZPropertiesForm')
    manage_ZPropertiesForm = Globals.DTMLFile("dtml/ZTemplate", globals(), in_ZMI=0, z_conteudo='gadgetPropertiesForm')

    security.declareProtected('Modificar Propriedades da XPagina','manage_ImagesForm')
    manage_ImagesForm = Globals.DTMLFile("dtml/gadgetImages", globals(), in_ZMI=1)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','gadgetImagesForm')
    gadgetImagesForm = Globals.DTMLFile("dtml/gadgetImages", globals(), in_ZMI=0)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','manage_ZImagesForm')
    manage_ZImagesForm = Globals.DTMLFile("dtml/ZTemplate", globals(), in_ZMI=0, z_conteudo='gadgetImagesForm')

    def __init__(self, id, title):
        self.id = id
        self.title = title

    security.declareProtected('Modificar Propriedades da XPagina', 'manage_Properties')
    def manage_Properties(self, title, data_inicial=None, data_final=None,
    texto="", mostrar_no_menu_superior=0, mostrar_no_menu_esquerdo=0, mostrar_no_menu_direito=0,
    usar_structured_text=0, in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do XPagina"
        self.title = title
        print dt2us(data_inicial)
        try: self.data_inicial = dt2us(data_inicial)
        except: self.data_inicial = dt2us()
        try: self.data_final = dt2us(data_final)
        except: self.data_final = dt2us('2030/01/01')
        self.mostrar_no_menu_superior = mostrar_no_menu_superior
        self.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
        self.mostrar_no_menu_direito = mostrar_no_menu_direito
        self._texto = texto
        self._usar_structured_text = usar_structured_text
        if self.getCatalogPrincipal() is not None and self.default_catalog != self.getCatalogPrincipal():
                self.manage_editCataloger(self.getCatalogPrincipal(), None)
        self.reindex_object()
        self.ZCacheable_invalidate()
        if REQUEST is not None:
          if in_ZMI:
            return self.manage_PropertiesForm(REQUEST, management_view='Propriedades',
                manage_tabs_message='A Pagina <strong>%s</strong> foi editada.' % self.id
                )
          else:
            return self.manage_ZPropertiesForm(REQUEST, management_view='Propriedades',
                manage_tabs_message='A Pagina <strong>%s</strong> foi editada.' % self.id
                )

Globals.default__class_init__(XPagina)

def manage_addXPagina(self, id, title, produtor=None, data_producao=None,
        data_inicial=None, data_final=None, texto="",
        mostrar_no_menu_superior=0, mostrar_no_menu_direito=0, mostrar_no_menu_esquerdo=0,
        usar_structured_text=0, REQUEST=None):
        """Cria um XPagina e o adiciona ao seu parent Folder.
        O argumento 'self' referencia o parent Folder.
        """
        pagina = XPagina(id, title)
        if produtor is None:
          if REQUEST is None:
            pagina.produtor = 'admin'
          else:
            pagina.produtor = REQUEST.AUTHENTICATED_USER.getId()
        else:
          pagina.produtor = produtor

        pagina.data_producao = dt2us()
        try: pagina.data_inicial = dt2us(data_inicial)
        except: pagina.data_inicial = dt2us()
        try: pagina.data_final = dt2us(data_final)
        except: pagina.data_final = dt2us('2030/01/01')
        pagina.mostrar_no_menu_superior = mostrar_no_menu_superior
        pagina.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
        pagina.mostrar_no_menu_direito = mostrar_no_menu_direito
        pagina._texto = texto
        pagina._usar_structured_text = usar_structured_text
        self._setObject(id, pagina)
        pagina = self.restrictedTraverse(id)
        if pagina.getCatalogPrincipal() is not None:
          pagina.manage_editCataloger(pagina.getCatalogPrincipal(), None)
          pagina.index_object()
        if REQUEST is not None:
                return self.manage_main(self, REQUEST)

manage_addXPaginaForm = Globals.DTMLFile('dtml/addXPaginaForm', globals())
