import ExtensionClass, OFS, Globals
from AccessControl import ClassSecurityInfo

class ZCoMIX_Common(ExtensionClass.Base):

    property_extensible_schema__ = 1

    security = ClassSecurityInfo()
    def filtered_propertyMap(self):
        result = []
        for i in self.propertyMap():
          if 'd' in i.get('mode', 'awd'):
            result.append(i)
        return result

    security.declareProtected('Manage properties', 'gadgetCustomProperties')
    gadgetCustomProperties = Globals.DTMLFile("dtml/gadgetCustomProperties", globals())

    old_manage_addProperty = OFS.PropertyManager.PropertyManager.manage_addProperty
    old_manage_delProperties = OFS.PropertyManager.PropertyManager.manage_delProperties
    old_manage_changeProperties = OFS.PropertyManager.PropertyManager.manage_changeProperties

    security.declareProtected('Manage properties','manage_addProperty')
    def manage_addProperty(self, id, value, type, in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do Objeto"
        self.old_manage_addProperty(id=id, value=value, type=type, REQUEST=None)
        if REQUEST is not None:
          if in_ZMI==1:
                return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)
          else:
                return self.manage_ZPropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

    security.declareProtected('Manage properties','manage_delProperties')
    def manage_delProperties(self, ids, in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do Objeto"
        self.old_manage_delProperties(ids, REQUEST=None)
        if REQUEST is not None:
          if in_ZMI==1:
                return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)
          else:
                return self.manage_ZPropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

    security.declareProtected('Manage properties','manage_changeProperties')
    def manage_changeProperties(self, in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do Objeto"
        if kw:
                apply(self.old_manage_changeProperties, [], kw)
        else:
                apply(self.old_manage_changeProperties, [], REQUEST.form)

        if REQUEST is not None:
          if in_ZMI==1:
                return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)
          else:
                return self.manage_ZPropertiesForm(REQUEST, management_view = 'Propriedades',
                        manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

